码迷,mamicode.com
首页 > 其他好文 > 详细

Leetcode -- Two Sum

时间:2015-04-18 13:09:35      阅读:130      评论:0      收藏:0      [点我收藏+]

标签:leetcode

Two Sum

题目

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

答案

O(n2) runtime, O(1) space – Brute force:

The brute force approach is simple. Loop through each element x and find if there is another value that equals to target – x. As finding another value requires looping through the rest of array, its runtime complexity is O(n2).

O(n) runtime, O(n) space – Hash table:

We could reduce the runtime complexity of looking up a value to O(1) using a hash map that maps a value to its index.

思路

  1. 一般人想到的是 Brute force, 蛮力匹配, 但是显然时间复杂度太高,是O(N^2),不符合要求。
  2. 思路是循环一次,每次都判断当前数组索引位置的值在不在hashtable里,不在的话,加入进去,key为数值,value为它的索引值;在的话,取得他的key,记为n(此时n一定小于循环变量i),接下来再在hashtable中查找(target-当前数值)这个数,利用了hashtable中查找元素时间为常数的优势。

代码

c++

class Solution {
public:
    vector<int> twoSum(vector<int> &numbers, int target) {
        int i, sum;
        vector<int> results;
        map<int, int> hmap;
        for(i=0; i<numbers.size(); i++){
            if(!hmap.count(numbers[i])){
                hmap.insert(pair<int, int>(numbers[i], i));
            }
            if(hmap.count(target-numbers[i])){
                int n=hmap[target-numbers[i]];
                if(n<i){
                    results.push_back(n+1);
                    results.push_back(i+1);
                    return results;
                }

            }
        }
        return results;
    }
};

java

import java.util.Hashtable;

public class Solution {
    public int[] twoSum(int[] numbers, int target) {
        int []a = new int[2];
        Hashtable<Integer, Integer> nums = new Hashtable<Integer, Integer>();
        for (int i=0; i<numbers.length; i++){
            Integer n = nums.get(numbers[i]);
            if (n==null) nums.put(numbers[i], i);
            n = nums.get(target - numbers[i]);
            if (n!=null && n<i){
                a[0]=n+1;
                a[1]=i+1;
                return a;
            }
        }
        return a;
    }
}

Leetcode -- Two Sum

标签:leetcode

原文地址:http://blog.csdn.net/mennoa/article/details/45112173

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!